// #autoload
// #author = Shane ^BuGs^ Froebel
// #email = bugs@tribalwar.com & bugs@optonline.net
// #status = Beta
// #version = 1.0.5
// #web = http://www.tribalwar.com/bugs/
// #description = A script that uses your mouse wheel to change your selected loadout or Weapon in T2.


function MouseCycle( %val )
{
     if ($BUGS::Cycle) {
           if ( %val < 0 )
           {
                 if ($BUGS::CurrentFav == 19)
                 {
                          $BUGS::CurrentFav = "0";
                 }
                 else
                 {
                          $BUGS::CurrentFav = $BUGS::CurrentFav + 1;
                }
        }
         else
         {
                 if ($BUGS::CurrentFav == 0)
                 {
                          $BUGS::CurrentFav = "19";
                 }
                 else
                 {
                          $BUGS::CurrentFav = $BUGS::CurrentFav - 1;
                }
        }
         loadFavorite($BUGS::CurrentFav);
         CyclesPopupPrint("Loadout: " @ $pref::FavNames[$BUGS::CurrentFav] @ " was selected.", 7);
     } else {
      if ( %val < 0 ) {
     
      commandToServer('cycleWeapon','next');
      
      } else {

      commandToServer('cycleWeapon','prev');

      }
     }
}

//GUI Code (Long for such a simple script)


function CyclesPopupPrint( %message, %time) // time is specified in seconds
{

        CyclesPopupClear();
        CyclesPopupDlg.position = $CyclesPopupDlgposition;
        CyclesPopupText.setText( "<just:center>" @ %message );
           CyclesPopupDlg.setVisible(true);

   if(%time > 0)
      CyclesPopupDlg.removePrint = schedule( ( %time * 1000 ), 0, "CyclesPopupClear" );
}

function CyclesPopupClear() {

        CyclesPopupDlg.setVisible(false);
        CyclesPopupText.setText( "" );
        CyclesPopupDlg.removePrint = "";
}

function SwitchCycleCmd(%press) {
 if(%press) {
  if ($BUGS::Cycle) {
    $BUGS::Cycle = 0;
    CyclesPopupPrint("Cycling Weapons", 5);
   } else {
    $BUGS::Cycle = 1;
    CyclesPopupPrint("Cycling Loadouts", 5);
  }
 }
}




package CyclesPopupLoad {

        function OptionsDlg::onWake( %this )
        {
                if($CyclesBind $= "false")
                {
                        $RemapName[$RemapCount]="SwitchCycle";
                        $RemapCmd[$RemapCount]="SwitchCycleCmd";
                        $RemapCount++;
                        $CyclesBind = "true";
                }
                parent::onWake( %this );
        }

function LoadingGui::onWake(%this)
{
        if(!$CyclesPopup::GUI) {
                CyclesPopupDlg();
                $CyclesPopup::GUI = "true";
                %x = getword($pref::Video::resolution, 0);
                %y = getword($pref::Video::resolution, 1);
                %xmulti = %x / 640;
                %ymulti = %y / 480;

                %x1 = getword($CyclesPopupPosition, 0);
                %y1 = getword($CyclesPopupPosition, 1);

                if(%x1 $= "50%") {
                        %x1 = mfloor(%x / 2) - 90;
                        %xmulti = 1;
                }

                $CyclesPopupDlgposition = mfloor(%x1 * %xmulti) @ " " @ mfloor(%y1 * %ymulti);
        }

        parent::onWake(%this);
}

function OptionsDlg::applyGraphicChanges( %this ) {

        parent::applyGraphicChanges( %this );

        %x = getword($pref::Video::resolution, 0);
        %y = getword($pref::Video::resolution, 1);
        %xmulti = %x / 640;
        %ymulti = %y / 480;

        %x1 = getword($CyclesPopupPosition, 0);
        %y1 = getword($CyclesPopupPosition, 1);

        if(%x1 $= "50%") {
                %x1 = mfloor(%x / 2) - 90;
                %xmulti = 1;
        }

        $CyclesPopupDlgposition = mfloor(%x1 * %xmulti) @ " " @ mfloor(%y1 * %ymulti);

}

function CyclesPopupDlg() {

        $CyclesPopupDlg = new ShellFieldCtrl(CyclesPopupDlg) {
                profile = "GuiChatBackProfile";
                horizSizing = "center";
                vertSizing = "top";
                position = "300 342";
                extent = "180 36";
                minExtent = "16 18";
                visible = "0";
                helpTag = "0";

                new GuiMLTextCtrl(CyclesPopupText) {
                        profile = "CyclesProfile";
                        horizSizing = "center";
                        vertSizing = "top";
                        position = "0 0";
                        extent = "176 34";
                        minExtent = "8 8";
                        visible = "1";
                        helpTag = "0";
                        lineSpacing = "2";
                        allowColorChars = "0";
                        maxChars = "-1";
                };
        };

        playgui.add($CyclesPopupDlg);
}

  // Added by Wizard_TPG

        function MouseConfigDlg::onWake( %this )
        {
                Parent::onWake( %this );
                MouseZActionMenu.add( "Cycle Weapons & Favourites", 4 );
                   if(%bind $= "Cycleourites")
                           %selId = 4;
                   MouseZActionMenu.setSelected( %selId );
        }

        function MouseConfigDlg::onOK( %this )
        {
                   Parent::onOK( %this );
                   if( MouseZActionMenu.getSelected() == 4)
                           moveMap.bind( mouse, zaxis, MouseCycle );
                   Canvas.popDialog( MouseConfigDlg );
        }

  // End of added part by Wizard_TPG

};

activatePackage(CyclesPopupLoad);

$CyclesBind = "false";
$CyclesPopup::GUI = "false";
$CyclesPopupPosition = "50% 300 180 36";

new GuiControlProfile ("CyclesProfile") {
        fontType = "Supertouch";
        fontSize = 14;
        fontColor = "255 255 255";
        autoSizeWidth = false;
        autoSizeHeight = true;
};

//GUI End